package com.company.jmixtest.entity

import io.jmix.core.DeletePolicy
import io.jmix.core.entity.annotation.JmixGeneratedValue
import io.jmix.core.entity.annotation.OnDeleteInverse
import io.jmix.core.metamodel.annotation.InstanceName
import io.jmix.core.metamodel.annotation.JmixEntity
import io.jmix.data.impl.lazyloading.NotInstantiatedList
import jakarta.persistence.*
import jakarta.persistence.Column
import jakarta.persistence.Table
import java.util.*

@JmixEntity
@Table(name = "JT_COLUMN_ENTITY", indexes = [
    Index(name = "IDX_JT_COLUMN_TABLE", columnList = "TABLE_ID")
])
@Entity(name = "jt_ColumnEntity")
open class ColumnEntity {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    var id: UUID? = null

    @InstanceName
    @Column(name = "NAME")
    var name: String? = null

    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "TABLE_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    var tableEntity: TableEntity? = null

    @JoinTable(
        name = "JT_PRIMARY_KEY_CONSTRAINT_COLUMN_LINK",
        joinColumns = [JoinColumn(name = "COLUMN_ID")],
        inverseJoinColumns = [JoinColumn(name = "PRIMARY_KEY_CONSTRAINT_ID")]
    )
    @ManyToMany
    var primaryKeyConstraints: MutableList<PrimaryKeyConstraint> = NotInstantiatedList()
}