package com.company.jmixtest.entity

import io.jmix.core.DataManager
import io.jmix.core.entity.annotation.JmixGeneratedValue
import io.jmix.core.metamodel.annotation.Composition
import io.jmix.core.metamodel.annotation.InstanceName
import io.jmix.core.metamodel.annotation.JmixEntity
import io.jmix.data.impl.lazyloading.NotInstantiatedList
import jakarta.annotation.PostConstruct
import jakarta.persistence.*
import jakarta.persistence.Column
import jakarta.persistence.Table
import java.util.*

@JmixEntity
@Table(name = "JT_TABLE_ENTITY", indexes = [
    Index(name = "IDX_JT_TABLE_PRIMARY_KEY_CONSTRAINT", columnList = "PRIMARY_KEY_CONSTRAINT_ID"),
    Index(name = "IDX_JT_TABLE_WATERMARK", columnList = "WATERMARK_ID")
])
@Entity(name = "jt_TableEntity")
open class TableEntity {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    var id: UUID? = null

    @InstanceName
    @Column(name = "NAME")
    var name: String? = null

    @Composition
    @OneToMany(mappedBy = "tableEntity")
    var columnEntities: MutableList<ColumnEntity> = NotInstantiatedList()

    @JoinColumn(name = "PRIMARY_KEY_CONSTRAINT_ID")
    @OneToOne(fetch = FetchType.LAZY)
    var primaryKeyConstraint: PrimaryKeyConstraint? = null

    @JoinColumn(name = "WATERMARK_ID")
    @OneToOne(fetch = FetchType.LAZY)
    var watermark: Watermark? = null

    @PostConstruct
    fun postConstruct(dataManager: DataManager) {
        primaryKeyConstraint = dataManager.create(PrimaryKeyConstraint::class.java)
        watermark = dataManager.create(Watermark::class.java)
    }
}