package com.company.jmixtest.view.table

import com.company.jmixtest.entity.ColumnEntity
import com.company.jmixtest.entity.TableEntity
import com.company.jmixtest.view.main.MainView
import com.vaadin.flow.component.Focusable
import com.vaadin.flow.component.grid.ItemDoubleClickEvent
import com.vaadin.flow.component.grid.contextmenu.GridMenuItem
import com.vaadin.flow.router.Route
import io.jmix.flowui.component.grid.DataGrid
import io.jmix.flowui.component.grid.editor.DataGridEditor
import io.jmix.flowui.kit.action.ActionPerformedEvent
import io.jmix.flowui.model.CollectionPropertyContainer
import io.jmix.flowui.model.DataContext
import io.jmix.flowui.view.*


@Route(value = "tableEntities/:id", layout = MainView::class)
@ViewController(id = "jt_TableEntity.detail")
@ViewDescriptor(path = "table-entity-detail-view.xml")
@EditedEntityContainer("tableEntityDc")
class TableEntityDetailView : StandardDetailView<TableEntity>() {

    @ViewComponent
    private lateinit var columnTable: DataGrid<ColumnEntity>

    @ViewComponent
    private lateinit var dataContext: DataContext

    @ViewComponent
    private lateinit var columnEntitiesDc: CollectionPropertyContainer<ColumnEntity>

    @Subscribe
    fun onInit(event: InitEvent?) {
        val tableEditor = columnTable.editor
        columnTable.addItemDoubleClickListener { e: ItemDoubleClickEvent<ColumnEntity> ->
            tableEditor.editItem(e.item)
            val editorComponent = e.column.editorComponent
            if (editorComponent is Focusable<*>) {
                (editorComponent as Focusable<*>).focus()
            }
        }
    }

    @Subscribe("columnTable.crate")
    private fun onColumnTableCrate(event: ActionPerformedEvent) {
        val columnEntity = dataContext.create(ColumnEntity::class.java)
        columnEntity.tableEntity = editedEntity

        columnEntitiesDc.mutableItems.add(columnEntity)
        columnTable.editor.editItem(columnEntity)
    }


}